---
title: 基本样式 
tags: bootstrap
categories: JavaScript
date: 2019-04-20
---

# 1.标题

在<h1>内可以嵌套<small>来定义一个颜色浅的文本。

# 2.强调文本

```html
<small>为父文本的百分之85
<strong> 更粗的文本
<em>斜体
<p class="text-left">向左对齐文本
<p class="text-center">居中
<p class="text-right">向右对齐
<p class="text-muted">内容减弱
* .text-muted：提示，浅灰色
* .text-primary：主要，蓝色
* .text-success：成功，浅绿色
* .text-info：通知信息，浅蓝色
* .text-warning：警告，黄色
* .text-danger：危险，红色
```

# 3.缩写

```html
<abbr title="Real Simple Sydication">RSS</abbr>
```

# 4.引用

`blockquote`

# 5.列表

```html
<!-- 未定义样式列表 -->
<ul class="list-unstyled">
	<li></li>
	<li></li>
	<li></li>
</ul>
<!-- 内联列表 -->
<ul class="inline">
	<li></li>
	<li></li>
	<li></li>
</ul>
<!-- 定义列表 -->
<dl>
	<dt>学号</dt>
	<dd>20150</dd>
	<dt>姓名</dt>
	<dd>王泽</dd>
</dl>
```

# 6.代码

```html
<p><code>String</code></p>
<pre>
	String name = "wangze"
</pre>
```

按键提示

```html
按<kbd>F10</kbd>进入全屏预览
```

代码滚动条

```html
<pre class="pre-scrollable"></pre>
```

# 7.表格

```html
<!-- 只有水平分割线的表格样式 -->
<table class="table">
<!-- 条纹表格 -->
<table class="table table-striped">
<!-- 边框表格 -->
<table class="table table-bordered">
<!-- 悬停表格 -->
<table class="table table-hover">
<!-- 精简表格,padding切半 -->
<table class="table table-condensed">
<!-- 上下文,改变表格行或单个单元格的背景颜色
.active     对某一行或单元格应用悬停颜色
.success
.warning
.danger   
-->
<!-- 响应式表格 -->
<div class="table-responsive">
```

# 8.表单

```html
<form role="form">
<div class="form-grou -->p">
<!-- 内联：标签并排 -->
<form class="form-inline" role="form">
<!-- 水平表单，把标签和控件放在一个带有class.form-group的<div>中 -->
<form class="form-horizontal" role="form">
<!-- 输入框 -->
<input type="text" class="form-control" placeholder="文本输入">
<!-- 文本框 -->
<textarea class="form-control" rows="3"></textarea>
<!-- 单选 -->
<div class="checkbox"> 
    <label><input type="checkbox" value="">选项 1</label>
</div>
<!-- 复选 -->
<div class="radio">
    <label><input type="radio" value="">选项 1</label>
</div>
<!-- 选择框 -->
<select class="form-control">
<!-- 静态控件 -->
<p class="form-control-static">
<!-- 表单控件大小
分别使用 class .input-lg 和 .col-lg-* 来设置表单的高度和宽度
表单帮助文档
 -->
<span class="help-block">
```

# 9.按钮

```html
<!-- 标准的按钮 --> 
<button type="button" class="btn btn-default">默认按钮</button> 
<!-- 提供额外的视觉效果，标识一组按钮中的原始动作 --> 
<button type="button" class="btn btn-primary">原始按钮</button> 
<!-- 表示一个成功的或积极的动作 --> 
<button type="button" class="btn btn-success">成功按钮</button> 
<!-- 信息警告消息的上下文按钮 --> 
<button type="button" class="btn btn-info">信息按钮</button> 
<!-- 表示应谨慎采取的动作 --> 
<button type="button" class="btn btn-warning">警告按钮</button> 
<!-- 表示一个危险的或潜在的负面动作 --> 
<button type="button" class="btn btn-danger">危险按钮</button> 
<!-- 并不强调是一个按钮，看起来像一个链接，但同时保持按钮的行为 --> 
<button type="button" class="btn btn-link">链接按钮</button>
```

`.btn-lg `       大按钮
`.btn-sm  `      较小按钮
`.btn-xs`                小按钮
`.btn-block`            块级按钮，会横跨父元素的全部宽度
`.active`        激活按钮
`.disabled`            禁用按钮
按钮样式适用于`a`标签，`button`标签，`input`标签
`.btn-group`        可在外层div定义，创建按钮组 `.btn-gtoup-lg|sm|xs`来控制大小
`.bth-group-vertical`        设置垂直方向
`.btn-group-justified `       自适应按钮

下拉菜单按钮，`.caret`显示下拉式功能

```html
<button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown"> 
    Sony <span class="caret"></span>
</button> 
<ul class="dropdown-menu" role="menu"> 
    <li><a href="#">Tablet</a></li> 
    <li><a href="#">Smartphone</a></li> 
</ul>
```

# 10.图片

* `.img-rounded`     为图片添加圆角

* `.img-circle`     将图片变为圆形

* `.img-thumbnail`     缩略图功能

* `.img-responsive`     图片响应式

# 11.文本

 展示不同颜色`.text-muted.text-primary.text-success.text-info.text-warning.text-danger`

# 12.文本背景颜色

`.bg-primary.bg-success.bg-info.bg-warning.bg-danger`

# 13.内容居中

`.center-block`