---
title: 布局组件 
tags: bootstrap
categories: JavaScript
date: 2019-03-21
---

# 1.字体图标

```html
<button type="button" class="btn btn-primary btn-lg" style="text-shadow: black 5px 3px 3px;">
  <span class="glyphicon glyphicon-user"></span> User
</button>
```

具体图标参考：[BootStrap字体图标](http://www.runoob.com/bootstrap/bootstrap-glyphicons.html)

# 2.下拉菜单

```html
<div class="dropdown">
    <button type="button" class="btn dropdown-toggle" id="dropdownMenu1" data-toggle="dropdown">
    主题<span class="caret"></span>
    </button>
<ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
	<li role="presentation">
		<a href="#" role="menuitem" tabindex="-1">JAVA</a>
	</li>
	<li role="presentation">
		<a href="#" role="menuitem" tabindex="-1">大数据</a>
	</li>
	<li role="presentation">
		<a href="#" role="menuitem" tabindex="-1">云计算</a>
	</li>
	<li role="presentation" class="divider"></li>
	<li role="presentation">
		<a href="#" role="menuitem" tabindex="-1">全栈工程师</a>
	</li>
</ul>
```

在`ul`的`class`中使用` pull-right`可以向界面右端对齐下拉菜单，也可以直接使用 `.dropdown-menu-right`。新建`li`标签`class="dropdown-header"`可以定义下拉菜单标题外层`div`定义` .dropup`可以向上弹出下拉菜单。

`.divider` 下拉菜单中的分割线

`.disabled`  下拉菜单中的禁用

`.dropdown`  指定下拉菜单，下拉菜单都包过在`.dropdown`中

`<span class="caret"></span>` 来指示按钮作为下拉菜单。

# 3.输入框

向 `.form-control` 添加前缀或后缀元素的步骤如下：

* 把前缀或后缀元素放在一个带有class` .input-group` 的 `<div>` 中。
* 接着，在相同的 `<div>` 内，在 `class` 为 `.input-group-addon` 的`<span>` 内放置额外的内容。
* 把该 `<span>` 放置在` <input>` 元素的前面或者后面。
* `<span>`内还可以放单选和复选框。同样可以添加`<button>`
* 把按钮作为输入框组的前缀或者后缀元素,这时不用`.input-group-addon`，而用class` .input-group-btn`，同样可以添加`<button>`或下拉菜单。
  可以通过向` .input-group` 添加相对表单大小的 class（比如 `.input-group-lg`、`input-group-sm`）来改变输入框组的大小。输入框中的内容会自动调整大小。