---
title: linux常用命令
tags: linux
categories: linux
date: 2019-03-11
---

## 简要

一些基本的linux命令，我认为像这些命令之类的，必须要多谢多用才能熟记。
#### 基本命令与解释
1.**mkdir**        创建目录

    -p    创建递归目录

2.**touch**        创建文件或修改文件时间

    -a    仅修改读取时间（atime）
    -m    仅修改修改时间（mtime）、
    -d    两者都修改

3.**cat**        查看文件

    -n    显示行号

4.**less**

    more        分页查看

5.**head**        从头查看

6.**tail**        从后看

    -f         实时查看日志文件

7.**grep**        筛选，常配合管道使用

    -n显示收集到信息的行号
    -v用于反选信息

8.**wc**        -l  统计行数、-w   字节数、-c  单词数

9.**du**        查看大小

10.**cp  (旧)  (新) **         复制

11.**mv  (旧)  (新)**         剪切或重命名

12.**useradd**        添加用户（只删除用户，目录保留，添加-r参数，用户目录都删除）

    userdel 删除用户
    
    whoami 查询当前用户名称

13.**groupadd**        添加用户组

14.**chmod [ugoa]+[rwx] 文件**

    chmod ___ 文件        4r    2w    1x

15.**echo**        输出

16.**date**        用于显示及设置系统的时间或日期

    -s “”设置时间

17.**reboot**        重启系统

18.**poweroff**        关闭系统

19.**wegt**        下周网络文件

    -p        下载到指定目录
    -r        递归下载

20.**ps**        查看系统中进程状态

    -aux
    显示：R（运行）S（终端）D（不可中断）Z（僵死）T（停止）

21.**top**        动态监视进程活动和系统负载信息

    第一行：系统时间    运行时间    显示终端数    系统负载
    
    第二行：进程总数    运行中的进程数    睡眠中的进程数    停止的进程数    僵死的进程数
    
    第三行：（百分比）用户占用    系统内核占用    改变过优先级的进程    空闲的资源
    
    第四行：物理内存总量比    内存使用量    内存空闲量    作为内存缓存的内存量
    
    第五行：虚拟内存总量    虚拟内存使用量    虚拟内存空闲量    已被提前加载的内存量

22.**pidof**        查询某个服务的pid值

23.**kill**        用于终止某个指定pid的服务进程

24.**killall**        终止某个指定名称的服务所对应的全部进程

25.**ifconfig**        获取网咖配置与网络状态信息

26.**uanme**        -a    查看系统内核与系统版本等信息

27.**uptime**        查看系统的负载信息

28.**free**        -h    显示当前系统中内存使用量情况

29.**who**        查看登入主机的用户终端信息

30.**last**        查看所有系统的登录记录

31.**history**        显示历史执行过的命令    通过“!命令符号”执行某条命令

    -c    清空

32.**sosreport**        收集系统配置及架构信息并输出诊断文档

33.**pwd**        显示当前目录

32.**cd**        切换目录

33.**ls**    ll        查看当前目录下的文件

34.**tr  (old) (new)**    替换文件中的字符

35.**stat**        查看文件具体存储信息和时间

    access    modify    change

36.**cut**        按列提取文本字符

    -d    紧跟分隔符
    -f    紧跟列号

37.**diff**        比较多个文件文本的差异

    --brief    判断文件是否相同
    -c       显示文件具体的不同

38.**rm**        删除

    -f    无需二次确认
    -rf    强制删除

39.**file**        查看文件的类型

40.**tar**        解压缩

    一般压缩-czvf    一般解压-xzvf

41.**find**        按照指定条件查找文件

    -name
    -user
    -group   
    -mtime -n +n        -n指n天以内，+n指n天以前
    -atime -n +n
    -ctime -n +n

42.**fdisk**    -l    查看磁盘

43.**vim编辑器**

    dd删除
    yy复制
    v撤销上一步操作
    p粘贴


​        

    :w    q     wq     q!    wq!
    :set nu         显示行号
    :set nonu        不显示行号
    :命令            执行该命令
    :整数        跳转到该行

44.**crontab**        定时任务

    -e编辑    -l查询    -r删除当前用户的所有任务
    
    编辑格式
    
            *    *    *    *    *
    
        第一个：一小时内的第几分钟执行0-59
    
        第二个：一天中的第几个小时执行0-23
    
        第三个：一个月中第几天执行1-31
    
        第四个：一年中当中的第几个月执行1-12
    
        第五个：一周当中星期几执行0-7（0和7都是周日）
    
    特殊符号
    
        * 任何时间    ，多个时间分割       - 连续时间    */n每个n执行一次
    
    无效服务时重启定时服务
    
    service crond restart

45.**sync**     将内存数据同步到磁盘，关机重启都应该执行

___