---
title: MySQL索引
date: 2019-03-25
tags: MySQL
categories: MySQL
---

# 1.索引的本质

* 索引是帮主MySQL高效获取数据的排好序的数据结构；

* 索引存储在文件里；

* 索引结构

  二叉树（红黑树） 

  HASH

  TREE

# 2.索引概述

磁盘存储原理

* 寻道时间（速度慢）
* 旋转时间（速度快）

# 3.B+TREE

* 非叶子节点不存储data，只存储key，可以增大度

* 叶子节点不存储指针 

* 顺序访问指针，提高区间访问的性能

* mysql中使用b+树的原因：

  非叶子节点不存储数据，这样索引加指针共14b，每个页16kb，这样能够增加容量，例如三层b+树，(16000/16)*(16000/16)*data

# 4.存储引擎

1. MyISAM（非聚集）

   叶子节点上的data不是数据本身，而是数据存放的地址。

2. innodb（聚集）
   * 表数据文件本身就是按B+树组织的一个索引结构文件
   * 聚集索引-叶节点包含了完成的数据记录
   * innodb必须有主键，并且推荐使用整形的自增主键，整型占用空间小，自增可以减少调整物理地址、分页等，自增会一页一页地写，索引机构相对紧凑，磁盘碎片少，效率高
   * 非主键索引结构的叶子节点存储的是主键值（一致性和存储空间）
   * 聚集索引使用情况
     * 主键列，该列在where子句中使用并且插入是随机的。
     * 在group by或order by中使用的列。
     * 不经常修改的列
     * 在连接操作中使用的列

# 5.B+Tree索引的性能分析

* 一般使用磁盘I/O次数评价索引结构的优劣
* 预读：磁盘一般会顺序向后读取一定长度的数据（页的整数倍）放入内存
* 局部性原理：当一个整数倍用到时，其附近的数据也通常会马上被使用
* B+Tree节点的大小设为等于一个页，每次新建节点直接申请一个页的空间，这样保证一个节点物理上也存储在一个页里，就实现了一个节点的载入只需要一次I/O
* B+Tree的度一般会超过100，因此h非常小（一般1到3，最多可能到5）
* 一般操作系统的最小存储单元为页，1页大小为4K
* 查看mysql文件页大小（16K）：SHOW GLOBAL STATUS like 'Innodb_page_size'

