---
title: Zookeeper和Eureka
tags: SpringCloud
categories: SpringCloud
date: 2019-07-28
---

CAP概念：
最多只能同时较好的满足两个。
CAP理论的核心是：一个分布式系统不可能同时很好的满足一致性、可用性和分区容错性这三个需求，因此，根据CAP原理将NoSQL数据库分成了满足CA原则、满足CP原则和满足AP原则三大类：

* CA：单点集群，满足一致性，可用性的系统，通常在可扩展性上不太强大。
* CP：满足一致性，分区容忍性的系统，通常性能不是特别高。
* AP：满足可用性，分区容忍性的系统，通常可能对一直性要求低一些。

1.Zookeeper保证CP
当向注册中心查询服务列表时，我们可以容忍注册中心返回的是几分钟以前的注册信息，但不能接受服务直接down掉不可用。也就是说，服务注册功能对可用性的要求要高于一致性。但是zk会出现这样一种情况，当master节点因为网络故障与其他节点失去联系时，剩余节点会重新进行leader选举。问题在于，选举leader的时间太长，30~120s，且选举期间整个zk集群都是不可用的，这就导致在选举期间注册服务瘫痪。在云部署环境下，因网络问题使得zk集群失去master节点是较大概率会发生的事，虽然服务最终能够恢复，但是漫长的选举时间导致的注册长期不可用是不能容忍的。
2.Eureka保证AP
Eureka在设计时优先保证可用性，Eureka各个节点都是平等的，几个节点挂掉不会影响正常节点的工作，剩余的节点依然可以提供注册和查询服务。而Eureka的客户端在向某个Eureka注册时如果发现连接失败，则会自动切换至其他节点，只要有一台Eureka还在，就能保住注册服务可用（保住可用性），只不过查到的信息可能不上最新的（不保证一致性）。除此之外，Eureka还有一种自我保护机制，如果15分钟内超过85%的节点都没有正常的心跳，那么Eureka就认为客户端与注册中心出现了网络故障，此时会出现以下几种情况：

* Eureka不再从注册列表中移除因为长时间没收到心跳而应该过去的服务
* Eureka仍然能够接受新服务的注册和查询请求，但是不会同步到其他节点上（即 保证当前节点依然可用）
* 当网络稳定时，当前实例新的注册信息会被同步到其他节点中。

>因此，Eureka可以很好的应对因网络故障导致部分节点失去联系的情况，而不会向zookeeper那样使整个注册服务瘫痪。