# 递归方法遍历二叉树

## 定义

二叉树是n个有限元素的集合，该集合或者为空、或者由一个称为根（root）的元素及两个不相交的、被分别称为左子树和右子树的二叉树组成，是一颗有序树。

## 先序遍历

先序遍历中的**先序**，是针对于根节点而言的。意思就是对于每一个子树，总是先输出根节点，然后再输出左子树，最后再输出右子树。同样的，对于左子树和右子树，同样需要根据先序遍历的规则进行。

```java
public void traversalBinaryTree(TreeNode root){
    if(null==root){
        return;
    }
    //先序遍历
    System.out.print(root.getVal()+" ");
    traversalBinaryTree(root.left);
    traversalBinaryTree(root.right);
}
```

## 中序遍历

中序遍历中的**中序**，也是针对于根节点而言的。意思就是对于每一个子树，总是先输出左子树，然后再输出根节点，最后再输出右子树。同样的，对于左子树和右子树，同样需要根据中序遍历的规则进行。

```java
public void traversalBinaryTree(TreeNode root){
    if(null==root){
        return;
    }
    //中序遍历
    traversalBinaryTree(root.left);
    System.out.print(root.getVal()+" ");
    traversalBinaryTree(root.right);
}
```

## 后序遍历

后序遍历中的**后序**，也是针对于根节点而言的。意思就是对于每一个子树，总是先输出左子树，然后再输出右子树，最后再输出根节点。同样的，对于左子树和右子树，同样需要根据后序遍历的规则进行。

```java
public void traversalBinaryTree(TreeNode root){
    if(null==root){
        return;
    }
    //后序遍历
    traversalBinaryTree(root.left);
    traversalBinaryTree(root.right);
    System.out.print(root.getVal()+" ");
}
```



# 参考

[递归方法遍历二叉树](https://www.daiyuma.com/195.html)

