# 一、敏捷项目管理基础

## 1. 项目管理

项目三角

* 范围：定义了要求做什么，也规定了不能做什么
* 时间：一个项目必须完成时间框架或者最后期限
* 成本：可用于项目的费用
* 质量
  * 产品质量：项目的可交付成功的质量
  * 过程质量：项目管理过程本身的质量

项目管理的目的是：

在**有限的资源**投入条件下，在**要求的时间**内，实现**既定的项目目标**。

## 2. Scrum方法



（1）3 3 3 5

* 3个理论支柱

  高透明性

  检查

  适应

* 3个角色

  产品负责人

  Scrum Master

  开发团队

* 3个工件

  产品代办列表

  迭代代办列表

  潜在可交付的产品增量

* 5个事件

  迭代计划会议

  迭代

  每日立会

  迭代评审会议

  迭代回顾会议

## 3.看板方法

三个原则：可视化、限制在制品、管理流动

五个核心实践

* 可视化工作（价值）流
* 限制在制品数量
* 度量和管理流动
* 协同改进
* 显示化流程规则

## 4.风险管理

四个阶段：

* 风险是被
* 风险分析
* 风险应对计划
* 风险监控和检测



# 二、需求管理与版本规划基础

## 1.需求层级

* Epic Story 史诗故事
* Feature 特性
* User Story 用户故事
  * 三要素：角色、活动、价值
  * 3C 原则
    * 卡片（Card）
    * 交谈（Conversation）
    * 确认（Confirmation）
  * 验收标准AC（Acceptance Criteria）
    * Given
    * When
    * Then

## 2.需求拆分

满足INVEST原则

独立性（Independent）

可协商性（Negotiable）

有价值（Valuable）

可以估算性（Estimable）

短小（Small）

可测的（Testable）

## 3.需求优先级

排优先级的方法

* MoSCoW法则（Must/Should/Could/WouldNot）

* 矩阵分析法

  重要且紧急>重要不紧急>紧急不重要>不重要也不紧急

* 满足核心用户需求的优先（二八原则）
* 满足核心业务的投入产出比最大的需求优先（ROI最大化）



# 三、软件测试与质量保证基础

## 1.软件测试与分类

分类：

* 按测试目的
  * 功能测试/系统测试（性能、容量、稳定性、可靠性、易用性、兼容性、安全性等非功能测试）
  * 冒烟测试/回归测试
* 按测试阶段
  * 单元测试- >模块测试- >集成测试- >系统测试- > 验收测试
* 按测试方法
  * 静态测试/动态测试
  * 白盒测试/黑盒测试

## 2.软件测试活动与设计方法

测试活动：

* 测试规划
  * 测试范围、时间、人员、优先级
  * 测试方法、环境
  * 测试风险
* 测试设计
  * 测试用例设计
  * 等价类、边界值
* 测试执行
  * 创建、执行测试计划
  * 环境、数据准备
  * 缺陷管理
* 测试报告
  * 测试进度
  * 缺陷趋势

## 3.探索式软件测试

不断迭代以上测试活动（测试规划、测试设计、测试执行、测试报告）

价值

1. 理解学习被测软件
2. 强迫被测软件展现所有功能
3. 快速发现重要缺陷

## 4.分层自动化

* 页面系统（手动+自动化）
* 业务集成（自动化）
* 底层服务（自动化）



# 四、云原生与DevOps

> 云原生：云原生技术有利于各组织在公有云、私有云和混合云等新型动态环境中，构建和运行可弹性扩展的应用。云原生的代表技术包括容器、服务网格、微服务、不可变的基础设施和声明式API。——CNCF



云计算模型：

* SaaS（软件即服务）
* PaaS（平台即服务）
* IaaS（基础设施即服务）

云计算三朵云：

* 公有云
* 混合云
* 私有云

CI/CD及DevOps

* CI Continuous Integration 持续集成
* CD Continuous Deployment 持续部署
* DevOps：开发运维一体化

![](https://oss.fuzui.net/img/20200922005048.png)