---
title: java设计模式之建造者模式Builder 
tags: [设计模式,Builder]
categories: 设计模式
date: 2019-04-01
---
***简介：***

>Builder是创建模式之一，是对象的创建模式。建造模式可以将一个产品的内部表象与产品的生产过程分割开来，从而可以使一个建造过程生产具有不同的内部表象的产品对象。
>建造模式利用一个导演者对象和具体建造者对象一个个地建造出所有的零件，从而建造出完整的产品对象。建造者模式将产品的结构和产品的零件的建造过程对客户端隐藏起来，把对建造过程进行指挥的责任和具体建造者零件的责任分割开来，达到责任划分和封装的目的。

<!-- more -->

#### 一、建造模式的角色和职责 ####

* Builder（抽象建造者）
给出一个抽象接口，以规范产品对象的各个组成成分的建造。此接口独立于应用程序的商业逻辑。ConcreteBuilder角色必须实现这个类所要求的两种方法：一种是建造方法（buildPart1和buildPart2），另一种是返回结构方法（retrieveResult）。产品角色所包含的零件数目与建造方法数目相同。

* ConcreteBuilder（具体建造者）
该角色直接创建产品对象。在应用程序调用下创建产品的实例。实现Builder接口，给出一步步完成创建产品实例的操作，在建造过程完成后，提供产品的实例。

* Director（导演者）
调用具体建造者对象以创建产品对象。

* Pruduct（产品）
是建造中的复杂对象。通常一个系统中会有多于衣蛾的产品类。

#### 二、类图 ####
![](https://fuzui.oss-cn-shenzhen.aliyuncs.com/img/20190401152413.png)
#### 三、时序图 ####
![](https://fuzui.oss-cn-shenzhen.aliyuncs.com/img/20190401162413.png)

#### 三、使用情况 ####
* 需要生成的产品对象有复杂的内部结构，每一个内部成分本身可以是对象，也可以仅仅是一个对象（产品对象）的一个组成部分。
* 需要生成的产品对象的属性相互依赖。建造模式可以强制实行一种分步骤进行的建造过程，因此，产品对象的一个属性必须在另一个属性被赋值之后才能被赋值。
* 在对象创建过程中会使用到系统中的其他一些对象，这些产品对象的创建过程不易得到。

参考：[java_my_life博主的《JAVA与模式》之建造者模式](http://www.cnblogs.com/java-my-life/archive/2012/04/07/2433939.html)