---
title: java设计模式之策略模式Strategy
tags: [设计模式,Strategy]
categories: 设计模式
date: 2019-03-30
---



***简介：***

>Strategy是行为模式之一，它对一系列的算法加以封装，为所有算法定义一个抽象的算法接口，并通过继承该抽象算法接口对所有算法加以封装和实现，具体的算法选择交由客户端决定（策略）。Strategy模式主要用来平滑地处理算法的切换。
>实现过程：定义策略接口->实现不同的策略类->利用多态或其他方式调用策略 

<!-- more -->
#### 一、策略模式的角色和职责 ####
* Context（环境）
	持有一个Strategy的引用，策略的外部封装类，或者策略的容器类。根据不同策略执行不同的行为，策略由外部环境决定。
* Strategy（抽象策略）
	是一个抽象角色，由一个接口或者一个抽象类来实现，为具体策略类提供所需接口
* ConcreteStrategy（具体策略）
	包装了相关算法或行为
#### 二、类图 ####
![](https://fuzui.oss-cn-shenzhen.aliyuncs.com/img/20190329194520.png)

#### 三、优缺点 ####
##### 1.优点 #####
（1）策略模式提供了管理相关算法的办法，策略类的等级结构定义了一个算法或行为族。恰当使用继承可以把公共的代码移到父类里面，从而避免重复的代码。
（2）策略模式提供可以替换继承关系的办法，继承可以处理多重算法或行为。
（3）使用策略模式可以避免使用多重 条件转移语句。

##### 2.缺点 #####
（1）客户端必须知道所有的策略类，并自行决定使用哪一个策略类。
（2）策略模式造成很多的策略类。有时候可以通过把依赖于环境的状态保存到客户端里面，而将策略类设计成可共享的，这样策略类实例可以被不同客户端使用。可以使用享元模式来减少对象的数量。

#### 四、应用 ####
##### 1.springmvc中 #####
（1）DispatchSelevt的初始组件中，用到getDefaultStrategies方法，来决定不同组件的默认类型以实现组件的初始化操作。
（2）在request的media type中。
##### 待补充... #####





参考：[java_my_life博主的《JAVA与模式》之策略模式](http://www.cnblogs.com/java-my-life/archive/2012/05/10/2491891.html)