---
title: java设计模式之简单工厂模式SimpleFactory
tags: [设计模式,SimpleFactory]
categories: 设计模式
date: 2019-04-02
---

***简介：***

>SimpleFactory是创建型模式之一。通过专门定义一个类来负责创建其他类的实例，被创建的实例通常都是具有共同的父类。简单工厂模式的实质是由一个工厂类根据传入的参数，动态决定应该创建哪一个产品类（这些产品类继承自一个父类或接口）的实例。

<!-- more -->

#### 一、角色和职责 ####
* Factory（工厂角色）
	简单工厂模式的核心，它负责实现创建所有实例的内部逻辑，工厂类可以被外界直接调用，创建所需的产品对象。
* Product （抽象角色）
	简单工厂模式所创建的所有对象的父类，它负责所有实例所共有的公共接口。
* ConcreteProduct（具体产品角色）
	简单工厂模式所创建的具体实例对象
#### 二、类图 ####
以手机生成为例：Phone为抽象角色类，Apple和HuaWei为具体产品角色类，PhoneFactory为工厂角色类。
![](https://fuzui.oss-cn-shenzhen.aliyuncs.com/img/20190402224727.png)

#### 三、优缺点 ####
* 优点
	工厂类是整个模式的关键所在。它包含必要的判断逻辑，能够根据外界给定的信息，决定究竟应该创建哪个具体类的对象。用户在使用时可以直接根据工厂类去创建所需的实例，而无需了解这些对象是如何创建以及如何组织的。有利于整个软件体系结构的优化。
* 缺点
	由于工厂类集中了所有实例的创建逻辑，所以“高内聚”方面做的并不好。另外，当系统中的具体产品类不断增多时，可能会出现要求工厂类也要做相应的修改，扩展性并不很好。

