---
title: linux /dev/vda1 占用100%
tags: linux
categories: 问题记录
date: 2019-07-26
---

情况：当使用`df -h`命令查看磁盘使用情况时发现/dev/vda1满了
解决：使用命令`du -sh * `看哪个目录占用空间大

*例如：*
最终我发现我小服务器上是tomcat的日志积累导致磁盘满了，所以删了之后，写个定时任务让它每天去清理一下七天以前的日志，以防下次再次爆满：
`crontab -e`
```shell
00 00 * * * /bin/find /www/server/tomcat/logs/ -type f -mtime +7 | xargs rm -f  &>/dev/null
```


参考:[tomcat日志切割和定期删除](https://blog.51cto.com/13178102/2070532)