---
title: 2019-04-16面试 
tags: 面试笔试
categories: 面试笔试
date: 2019-04-16
---

#### 一、解释一下java中的堆和栈以及java内存。 ####

java程序运行时，会有七种内存区域：

1.寄存器：JVM内存虚拟的寄存器跟CPU有关，程序无法控制。

2.常量池：JVM对于每个已经加载的类型都会维护一个常量池，常量池是该类型用到的所有常量的一个有序集合。常量池位于堆内存区域。

3.代码段：用来存放存储设备中读取的代码片段。

4.数据段：用来存放静态成员，包括静态变量、静态常量、静态方法、静态类。

5.方法区：用来存储所有函数。

6.堆：用来存储程序动态产生的数据。存储new创建的对象和数组。堆内存中所有实体 都有内存地址值，实体是用来封装数据的，都有初始值，当实体不再被指向时，JVM启用垃圾回收机制，不定时自动清除。

7.栈：存放函数中定义的基本类型变量、对象的引用变量。栈中数据没有初始值，需要手动设置。用完立刻消失，释放内存。拥有栈帧。

#### 二、String、StringBuffer和StringBuilder的区别 ####

1.可变与不可变

String类中使用字符数组来存储字符串，private final char value[]，因为有final修饰符，所以String是不可变的；

StringBuilder与StringBuffer都继承自AbstractStringBuilder类，在AbstractStringBuilder中也是使用字符数组保存字符串，这两种是可变的。

2.是否线程安全

String不可变，即常量，线程安全；

AbstractStringBuilder是StringBuilder与StringBuffer的公共父类，定义了一些字符串的基本操作，如expandCapacity、append、insert、indexOf等公共方法。

StringBuffer对方法加了同步锁或者对调用的方法加了同步锁，所以是线程安全的。
StringBuilder并没有对方法进行加同步锁，所以是非线程安全的。

3.适用情况

String：适用于少量的字符串操作的情况；

StringBuilder：适用于单线程下在字符缓冲区进行大量操作的情况；

StringBuffer：适用多线程下在字符缓冲区进行大量操作的情况。

#### 三、抽象类与接口的不同 ####
参数	抽象类	接口
* 默认的方法实现	
   抽象类它可以有默认的方法实现	
   接口完全是抽象的。它根本不存在方法的实现(jdk1.8中添加了default默认方法)
* 实现	
抽象类子类使用extends关键字来继承抽象类。
接口子类使用关键字implements来实现接口。
* 构造器	
抽象类可以有构造器	
接口不能有构造器
* 与正常Java类的区别
抽象类除了不能实例化抽象类之外，它和普通Java类没有任何区别	
接口是完全不同的类型
* 访问修饰符	
抽象类中抽象方法可以有public、protected和default这些修饰符	
接口方法默认修饰符是public。不可以使用其它修饰符。
* main方法	
抽象方法可以有main方法并且可以运行它	
接口没有main方法，因此不能运行它。
* 多继承	
抽象方法可以继承一个类和实现多个接口	
接口只可以继承一个或多个其它接口
* 速度	
抽象类比接口速度要快	
接口是稍微有点慢的，因为它需要时间去寻找在类中实现的方法。
* 添加新方法	
如果往抽象类中添加新的方法，你可以给它提供默认的实现。因此不需要改变你现在的代码。	
如果往接口中添加方法，那么你必须改变实现该接口的类。

 #### 四、有四个数1,2,3,4，组合成三位数，有多少种，各是什么 ####
 ```linux
 package javase;
/**
 * @author fuzui
 * @date 2019年2月26日 下午4:06:12
 * 
 * 有四个数1,2,3,4，组合成三位数，有多少种，各是什么
 */
public class Main05 {
	public static void main(String[] args) {
		int count = 0;
		for(int i = 1;i<5;i++) {
			for(int j = 1;j<5;j++) {
				for(int k = 1;k<5;k++) {
					if(i!=j && i!=k && j!=k) {
						count++;
						System.out.println(i*100+j*10+k);
					}
				}
			}
		}
		System.out.println("共"+count+"个");
	}
}
 ```

